package com.bytescout;

import com.bytescout.barcodereader.BarcodeOrientation;
import com.bytescout.barcodereader.Reader;
import com.bytescout.barcodereader.ScanArea;
import java.awt.Frame;
import java.nio.charset.Charset;
import java.util.EnumSet;
import java.util.SortedMap;
import javax.swing.DefaultComboBoxModel;

public class Options extends javax.swing.JDialog
{
	private Reader reader;
	
	public Options(Frame owner, Reader reader)
	{
		super(owner);
		
		this.reader = reader;
		
		initComponents();
		
		// center over the parent frame
		setLocationRelativeTo(owner);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
	 * content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        pageCommonOptions = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        tfMaxBarcodesPerPage = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        cbTopLeftQuarter = new javax.swing.JCheckBox();
        cbBottomLeftQuarter = new javax.swing.JCheckBox();
        cbTopRightQuarter = new javax.swing.JCheckBox();
        cbBottomRightQuarter = new javax.swing.JCheckBox();
        tfMinimalDataLength = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        page1DOptions = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        cbVerticalMinus90 = new javax.swing.JCheckBox();
        cbRotatedMinus45 = new javax.swing.JCheckBox();
        cbRotatedMinus22 = new javax.swing.JCheckBox();
        cbRotatedMinus11 = new javax.swing.JCheckBox();
        cbHorizontal = new javax.swing.JCheckBox();
        cbRotated11 = new javax.swing.JCheckBox();
        cbRotated22 = new javax.swing.JCheckBox();
        cbRotated45 = new javax.swing.JCheckBox();
        cbVertical90 = new javax.swing.JCheckBox();
        cbHorizontalFlipped = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        cbRotatedMinus11Flipped = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        cbRotatedMinus22Flipped = new javax.swing.JCheckBox();
        cbRotatedMinus45Flipped = new javax.swing.JCheckBox();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        cbRotated11Flipped = new javax.swing.JCheckBox();
        jLabel8 = new javax.swing.JLabel();
        cbRotated22Flipped = new javax.swing.JCheckBox();
        jLabel9 = new javax.swing.JLabel();
        cbRotated45Flipped = new javax.swing.JCheckBox();
        cbSearchNegative = new javax.swing.JCheckBox();
        cbRequireQuietZone = new javax.swing.JCheckBox();
        cbOrphanedSupplementals = new javax.swing.JCheckBox();
        page2DOptions = new javax.swing.JPanel();
        cmbTextEncoding = new javax.swing.JComboBox();
        jLabel10 = new javax.swing.JLabel();
        btnCancel = new javax.swing.JButton();
        btnOK = new javax.swing.JButton();
        btnDefaults = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Options");
        addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentShown(java.awt.event.ComponentEvent evt)
            {
                formComponentShown(evt);
            }
        });

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(50, 50));

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel1.setText("Max number of barcodes per page (0 for unlimited)");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Page areas where to search barcodes (UNCHECK UNWANTED FOR FASTER DECODING)"));

        cbTopLeftQuarter.setSelected(true);
        cbTopLeftQuarter.setText("Top-Left quarter");

        cbBottomLeftQuarter.setSelected(true);
        cbBottomLeftQuarter.setText("Bottom-Left quarter");

        cbTopRightQuarter.setSelected(true);
        cbTopRightQuarter.setText("Top-Right quarter");

        cbBottomRightQuarter.setSelected(true);
        cbBottomRightQuarter.setText("Bottom-Right quarter");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cbTopLeftQuarter)
                    .addComponent(cbBottomLeftQuarter))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cbTopRightQuarter)
                    .addComponent(cbBottomRightQuarter))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(cbTopRightQuarter)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cbBottomRightQuarter))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(cbTopLeftQuarter)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cbBottomLeftQuarter))
        );

        jLabel2.setText("Minimal decoded data length");

        javax.swing.GroupLayout pageCommonOptionsLayout = new javax.swing.GroupLayout(pageCommonOptions);
        pageCommonOptions.setLayout(pageCommonOptionsLayout);
        pageCommonOptionsLayout.setHorizontalGroup(
            pageCommonOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pageCommonOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pageCommonOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(pageCommonOptionsLayout.createSequentialGroup()
                        .addGroup(pageCommonOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(pageCommonOptionsLayout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(tfMaxBarcodesPerPage, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(pageCommonOptionsLayout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(tfMinimalDataLength, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 146, Short.MAX_VALUE)))
                .addContainerGap())
        );
        pageCommonOptionsLayout.setVerticalGroup(
            pageCommonOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pageCommonOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pageCommonOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(tfMaxBarcodesPerPage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pageCommonOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tfMinimalDataLength, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addContainerGap(192, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Common", pageCommonOptions);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Barcode orientations to scan (MORE CHECKED - MORE SLOWER)"));

        cbVerticalMinus90.setText("Vertical -90°");

        cbRotatedMinus45.setText("Rotated -45°");

        cbRotatedMinus22.setText("Rotated -22°");

        cbRotatedMinus11.setText("Rotated -11°");

        cbHorizontal.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        cbHorizontal.setText("Horizontal");

        cbRotated11.setText("Rotated 11°");

        cbRotated22.setText("Rotated 22°");

        cbRotated45.setText("Rotated 45°");

        cbVertical90.setText("Vertical 90°");

        cbHorizontalFlipped.setText("flipped");

        jLabel3.setText("+");

        jLabel4.setText("+");

        cbRotatedMinus11Flipped.setText("flipped");

        jLabel5.setText("+");

        cbRotatedMinus22Flipped.setText("flipped");

        cbRotatedMinus45Flipped.setText("flipped");

        jLabel6.setText("+");

        jLabel7.setText("+");

        cbRotated11Flipped.setText("flipped");

        jLabel8.setText("+");

        cbRotated22Flipped.setText("flipped");

        jLabel9.setText("+");

        cbRotated45Flipped.setText("flipped");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cbVerticalMinus90)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cbRotatedMinus45)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(21, 21, 21)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(cbRotatedMinus22)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addGap(21, 21, 21)
                                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                                        .addGap(21, 21, 21)
                                                        .addComponent(cbHorizontal))
                                                    .addComponent(cbRotatedMinus11)
                                                    .addComponent(cbRotated11)))
                                            .addComponent(cbRotated22))
                                        .addGap(18, 18, 18)
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel8)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbRotated22Flipped))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel7)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbRotated11Flipped))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel4)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbRotatedMinus11Flipped))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel3)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbHorizontalFlipped))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel5)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbRotatedMinus22Flipped))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel6)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbRotatedMinus45Flipped))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jLabel9)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(cbRotated45Flipped))))))
                            .addComponent(cbRotated45)))
                    .addComponent(cbVertical90))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(cbVerticalMinus90)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbRotatedMinus45Flipped)
                        .addComponent(jLabel6))
                    .addComponent(cbRotatedMinus45))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbRotatedMinus22Flipped)
                        .addComponent(jLabel5))
                    .addComponent(cbRotatedMinus22))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbRotatedMinus11Flipped)
                        .addComponent(jLabel4))
                    .addComponent(cbRotatedMinus11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cbHorizontal)
                    .addComponent(cbHorizontalFlipped)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbRotated11Flipped)
                        .addComponent(jLabel7))
                    .addComponent(cbRotated11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbRotated22Flipped)
                        .addComponent(jLabel8))
                    .addComponent(cbRotated22))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(cbRotated45Flipped)
                        .addComponent(jLabel9))
                    .addComponent(cbRotated45))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cbVertical90))
        );

        cbSearchNegative.setText("Search negative barcodes");

        cbRequireQuietZone.setText("Require \"quite zones\" before and after barcode");

        cbOrphanedSupplementals.setText("Decode orphaned supplemental barcodes (EAN-2 or EAN-5 without parent EAN-13)");

        javax.swing.GroupLayout page1DOptionsLayout = new javax.swing.GroupLayout(page1DOptions);
        page1DOptions.setLayout(page1DOptionsLayout);
        page1DOptionsLayout.setHorizontalGroup(
            page1DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(page1DOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(page1DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(page1DOptionsLayout.createSequentialGroup()
                        .addGroup(page1DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cbOrphanedSupplementals)
                            .addComponent(cbRequireQuietZone)
                            .addComponent(cbSearchNegative))
                        .addGap(0, 71, Short.MAX_VALUE)))
                .addContainerGap())
        );
        page1DOptionsLayout.setVerticalGroup(
            page1DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(page1DOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cbSearchNegative)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cbRequireQuietZone)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cbOrphanedSupplementals)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("One-dimensional (1D) barcodes", page1DOptions);

        jLabel10.setText("Text charset");

        javax.swing.GroupLayout page2DOptionsLayout = new javax.swing.GroupLayout(page2DOptions);
        page2DOptions.setLayout(page2DOptionsLayout);
        page2DOptionsLayout.setHorizontalGroup(
            page2DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(page2DOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cmbTextEncoding, javax.swing.GroupLayout.PREFERRED_SIZE, 148, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(285, Short.MAX_VALUE))
        );
        page2DOptionsLayout.setVerticalGroup(
            page2DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(page2DOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(page2DOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cmbTextEncoding, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10))
                .addContainerGap(297, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Two-dimensional (2D) barcodes", page2DOptions);

        btnCancel.setText("Cancel");
        btnCancel.setPreferredSize(new java.awt.Dimension(75, 23));
        btnCancel.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnCancelActionPerformed(evt);
            }
        });

        btnOK.setText("OK");
        btnOK.setPreferredSize(new java.awt.Dimension(75, 23));
        btnOK.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnOKActionPerformed(evt);
            }
        });

        btnDefaults.setText("Set defaults");
        btnDefaults.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                btnDefaultsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnDefaults)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 272, Short.MAX_VALUE)
                        .addComponent(btnOK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 356, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnOK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnDefaults))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
    {//GEN-HEADEREND:event_formComponentShown
        tfMaxBarcodesPerPage.setText(String.valueOf(reader.getMaxNumberOfBarcodesPerPage()));
		
		// search area
		cbTopLeftQuarter.setSelected(reader.getScanArea().contains(ScanArea.TopLeftQuarter));
		cbBottomLeftQuarter.setSelected(reader.getScanArea().contains(ScanArea.BottomLeftQuarter));
		cbTopRightQuarter.setSelected(reader.getScanArea().contains(ScanArea.TopRightQuarter));
		cbBottomRightQuarter.setSelected(reader.getScanArea().contains(ScanArea.BottomRightQuarter));
		
		tfMinimalDataLength.setText(String.valueOf(reader.getMinimalDataLength()));
		
		// orientation
		cbVerticalMinus90.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.VerticalFromBottomToTop));
		cbRotatedMinus45.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromBottomLeftToTopRight45));
		cbRotatedMinus45Flipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromTopRightToBottomLeft45));
		cbRotatedMinus22.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromBottomLeftToTopRight22));
		cbRotatedMinus22Flipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromTopRightToBottomLeft22));
		cbRotatedMinus11.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromBottomLeftToTopRight11));
		cbRotatedMinus11Flipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromTopRightToBottomLeft11));
		cbHorizontal.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.HorizontalFromLeftToRight));
		cbHorizontalFlipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.HorizontalFromRightToLeft));
		cbRotated11.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromTopLeftToBottomRight11));
		cbRotated11Flipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromBottomRightToTopLeft11));
		cbRotated22.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromTopLeftToBottomRight22));
		cbRotated22Flipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromBottomRightToTopLeft22));
		cbRotated45.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromTopLeftToBottomRight45));
		cbRotated45Flipped.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.DiagonalFromBottomRightToTopLeft45));
		cbVertical90.setSelected(reader.getBarcodeOrientations().contains(BarcodeOrientation.VerticalFromTopToBottom));
		
		// other
		cbSearchNegative.setSelected(reader.isSearchNegative());
		cbRequireQuietZone.setSelected(reader.isRequireQuietZones());
		cbOrphanedSupplementals.setSelected(reader.isAllowOrphanedSupplementals());
		
		SortedMap<String, Charset> availableCharsets = Charset.availableCharsets();
		cmbTextEncoding.setModel(new DefaultComboBoxModel(availableCharsets.keySet().toArray()));
		cmbTextEncoding.setSelectedItem(reader.getCharset().name());
    }//GEN-LAST:event_formComponentShown

    private void btnDefaultsActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnDefaultsActionPerformed
    {//GEN-HEADEREND:event_btnDefaultsActionPerformed
        tfMaxBarcodesPerPage.setText("0");
		
		cbTopLeftQuarter.setSelected(true);
		cbBottomLeftQuarter.setSelected(true);
		cbTopRightQuarter.setSelected(true);
		cbBottomRightQuarter.setSelected(true);
		
		tfMinimalDataLength.setText("0");
		
		cbVerticalMinus90.setSelected(false);
		cbRotatedMinus45.setSelected(false);
		cbRotatedMinus45Flipped.setSelected(false);
		cbRotatedMinus22.setSelected(false);
		cbRotatedMinus22Flipped.setSelected(false);
		cbRotatedMinus11.setSelected(false);
		cbRotatedMinus11Flipped.setSelected(false);
		cbHorizontal.setSelected(true);
		cbHorizontalFlipped.setSelected(false);
		cbRotated11.setSelected(false);
		cbRotated11Flipped.setSelected(false);
		cbRotated22.setSelected(false);
		cbRotated22Flipped.setSelected(false);
		cbRotated45.setSelected(false);
		cbRotated45Flipped.setSelected(false);
		cbVertical90.setSelected(false);
		
		cbSearchNegative.setSelected(false);
		cbRequireQuietZone.setSelected(true);
		cbOrphanedSupplementals.setSelected(false);
		
		cmbTextEncoding.setSelectedItem(Charset.defaultCharset().name());
    }//GEN-LAST:event_btnDefaultsActionPerformed

    private void btnOKActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnOKActionPerformed
    {//GEN-HEADEREND:event_btnOKActionPerformed
        reader.setMaxNumberOfBarcodesPerPage(Integer.valueOf(tfMaxBarcodesPerPage.getText()));
				
		EnumSet<ScanArea> scanAreas = EnumSet.noneOf(ScanArea.class);
		if (cbTopLeftQuarter.isSelected())
			scanAreas.add(ScanArea.TopLeftQuarter);
		if (cbBottomLeftQuarter.isSelected())
			scanAreas.add(ScanArea.BottomLeftQuarter);
		if (cbTopRightQuarter.isSelected())
			scanAreas.add(ScanArea.TopRightQuarter);
		if (cbBottomRightQuarter.isSelected())
			scanAreas.add(ScanArea.BottomRightQuarter);
		reader.setScanArea(scanAreas);
		
		reader.setMinimalDataLength(Integer.valueOf(tfMinimalDataLength.getText()));
		
		EnumSet<BarcodeOrientation> orientations = EnumSet.noneOf(BarcodeOrientation.class);
		if (cbVerticalMinus90.isSelected()) 
			orientations.add(BarcodeOrientation.VerticalFromBottomToTop);
		if (cbRotatedMinus45.isSelected()) 
			orientations.add(BarcodeOrientation.DiagonalFromBottomLeftToTopRight45);
		if (cbRotatedMinus45Flipped.isSelected()) 
			orientations.add(BarcodeOrientation.DiagonalFromTopRightToBottomLeft45);
		if (cbRotatedMinus22.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromBottomLeftToTopRight22);
		if (cbRotatedMinus22Flipped.isSelected()) 
			orientations.add(BarcodeOrientation.DiagonalFromTopRightToBottomLeft22);
		if (cbRotatedMinus11.isSelected()) 
			orientations.add(BarcodeOrientation.DiagonalFromBottomLeftToTopRight11);
		if (cbRotatedMinus11Flipped.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromTopRightToBottomLeft11);
		if (cbHorizontal.isSelected())
			orientations.add(BarcodeOrientation.HorizontalFromLeftToRight);
		if (cbHorizontalFlipped.isSelected()) 
			orientations.add(BarcodeOrientation.HorizontalFromRightToLeft);
		if (cbRotated11.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromTopLeftToBottomRight11);
		if (cbRotated11Flipped.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromBottomRightToTopLeft11);
		if (cbRotated22.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromTopLeftToBottomRight22);
		if (cbRotated22Flipped.isSelected()) 
			orientations.add(BarcodeOrientation.DiagonalFromBottomRightToTopLeft22);
		if (cbRotated45.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromTopLeftToBottomRight45);
		if (cbRotated45Flipped.isSelected())
			orientations.add(BarcodeOrientation.DiagonalFromBottomRightToTopLeft45);
		if (cbVertical90.isSelected())
			orientations.add(BarcodeOrientation.VerticalFromTopToBottom);
		reader.setBarcodeOrientations(orientations);
		
		reader.setSearchNegative(cbSearchNegative.isSelected());
		reader.setRequireQuietZones(cbRequireQuietZone.isSelected());
		reader.setAllowOrphanedSupplementals(cbOrphanedSupplementals.isSelected());
		
		reader.setCharset(Charset.availableCharsets().get(cmbTextEncoding.getSelectedItem()));
		
		this.setVisible(false);
    }//GEN-LAST:event_btnOKActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnCancelActionPerformed
    {//GEN-HEADEREND:event_btnCancelActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnDefaults;
    private javax.swing.JButton btnOK;
    private javax.swing.JCheckBox cbBottomLeftQuarter;
    private javax.swing.JCheckBox cbBottomRightQuarter;
    private javax.swing.JCheckBox cbHorizontal;
    private javax.swing.JCheckBox cbHorizontalFlipped;
    private javax.swing.JCheckBox cbOrphanedSupplementals;
    private javax.swing.JCheckBox cbRequireQuietZone;
    private javax.swing.JCheckBox cbRotated11;
    private javax.swing.JCheckBox cbRotated11Flipped;
    private javax.swing.JCheckBox cbRotated22;
    private javax.swing.JCheckBox cbRotated22Flipped;
    private javax.swing.JCheckBox cbRotated45;
    private javax.swing.JCheckBox cbRotated45Flipped;
    private javax.swing.JCheckBox cbRotatedMinus11;
    private javax.swing.JCheckBox cbRotatedMinus11Flipped;
    private javax.swing.JCheckBox cbRotatedMinus22;
    private javax.swing.JCheckBox cbRotatedMinus22Flipped;
    private javax.swing.JCheckBox cbRotatedMinus45;
    private javax.swing.JCheckBox cbRotatedMinus45Flipped;
    private javax.swing.JCheckBox cbSearchNegative;
    private javax.swing.JCheckBox cbTopLeftQuarter;
    private javax.swing.JCheckBox cbTopRightQuarter;
    private javax.swing.JCheckBox cbVertical90;
    private javax.swing.JCheckBox cbVerticalMinus90;
    private javax.swing.JComboBox cmbTextEncoding;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JPanel page1DOptions;
    private javax.swing.JPanel page2DOptions;
    private javax.swing.JPanel pageCommonOptions;
    private javax.swing.JTextField tfMaxBarcodesPerPage;
    private javax.swing.JTextField tfMinimalDataLength;
    // End of variables declaration//GEN-END:variables
}
